/*
  Modul nRF24
  part of Arduino Mega Server project
*/

#ifdef NRF24_FEATURE

#include <SPI.h>
#include "RF24.h"

// nRF24L01 modul configuration
RF24 radio(0 ,2); // CE, CSN pins 8,9
byte addresses[][6] = {"5Node", "6Node"};

// packet buffers
#define PACKET_MAX_BYTES 32
byte buffTx[PACKET_MAX_BYTES];
byte buffRx[PACKET_MAX_BYTES];

// packet structure
#define POS_TYPE      0
#define POS_COMMAND   1
#define POS_ADDR      2
#define POS_DEST      3
#define POS_REQUIRED  4
#define POS_NUMBER    5
#define POS_PASSWORD  9
#define POS_DATA      17

// set 1

#define POS_VOL_1     28 
#define POS_CONT_1    17 // 1
#define POS_TEMP_1    18 // 6
#define POS_BATTERY   24 // 3
#define POS_RESERVE   27 // 5

#define  TEMP_1_LEN  POS_BATTERY - POS_TEMP_1
#define BATTERY_LEN  POS_RESERVE - POS_BATTERY

// packet type
#define TYPE_EMPTY   0
#define TYPE_COMMAND 1
#define TYPE_REQUEST 2
#define TYPE_DATA    3
#define TYPE_ALARM   4
#define TYPE_ANSWER  5
#define TYPE_ECHO    6

// packet variables
byte   rxType;
byte   rxCommand;
byte   rxAddr;
byte   rxDestination;
byte   rxRequired;
byte   rxNumber;
String rxPassword;
String rxData;

// required answer
#define NOT_REQUIRED 0
#define REQUIRED     1

// logic
#define NOT_DEF 0
#define OUT     0
#define IN      1


void nrf24Init() {
  
 // initStart("nRF24", true);

   initStart("nRF24");
   
  timeStamp();
  Serial.println(F(" Base Receiving"));
  radio.begin();
  radio.setPALevel(RF24_PA_MAX); // default RF24_PA_MAX
  
  radio.openWritingPipe(addresses[0]);
  radio.openReadingPipe(1, addresses[1]);
    
  radio.startListening();

 // serialDynamic = ACTIVE;
  modulNrf24 = MODUL_ENABLE;
//  initDone(true);
   initDone();

}

void nrf24Works() {

}

#endif // NRF24_FEATURE
