/*
  Modul RobotDyn
  part of Arduino Mega Server project
*/

#ifdef ROBOTDYN_FEATURE

bool sFlag = true;
unsigned long megaTimer = millis();

// Serial request
#define MAX_SERIAL_REQ  32
String serialReq = "";

void robotdynInit() {
  modulRobotdyn = MODUL_ENABLE;
  started("RobotDyn");
}

void printSerialStr() {
  Serial.println(serialReq);
}

void parseSerialCmd() {
  String command;
  String parameter;
  
  if (serialReq.indexOf(F("?")) >= 0) {
    int pBegin = serialReq.indexOf(F("?")) + 1;
    if (serialReq.indexOf(F("=")) >= 0) {
       int pParam = serialReq.indexOf(F("="));
       command   = serialReq.substring(pBegin, pParam);              
       parameter = serialReq.substring(pParam + 1);              
    } else {
        command = serialReq.substring(pBegin);              
        parameter = "";
      }
      
    if (command != F("mega")) {
      Serial.print(F("command/parameter: "));
      Serial.print(command);
      Serial.print(F("/"));
      Serial.println(parameter);
    }

    if (command == F("mega")) {
      if (parameter == F("1")) {
        mega = 1;
        megaTimer = millis();
      } else {
          mega = 0;
        }
    }
  } // if (request.indexOf(F("?")) >= 0)
} // parseSerialCmd()

void parseSerialStr() {
  if (serialReq[0] == '?') {
    parseSerialCmd();
  } else {
      printSerialStr();
    }
}

void checkSerial() {
  while (Serial.available() > 0) {
    if (sFlag) {
      serialReq = "";
      sFlag = false;
    }
    char c = Serial.read();
    if (c == 10) {
      sFlag = true;
      parseSerialStr();
    }
    else if (c == 13) {
      // skip
    }
    else {
      if (serialReq.length() < MAX_SERIAL_REQ) {
        serialReq += c;
      }
    } // if
  } // while (Serial3.available() > 0)
} // checkSerial()

void robotdynWorks() {
  checkSerial();
  if (cycle4s) {
    Serial.println(F("?esp=1"));
    if (millis() - megaTimer > 8000) {mega = 0;}
  }
}

#endif // ROBOTDYN_FEATURE
